SystemOrganization addCategory: #'Seaside-Pharo20-Core-Document'!

!GRPackage class methodsFor: '*seaside-pharo20-core' stamp: 'pmm 8/4/2012 18:47'!
seasidePharo20Core
	^ self new
		name: 'Seaside-Pharo20-Core';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Pharo20-Core';
		url: #seasideUrl;
		yourself! !

WAEncoder subclass: #WAPharoEncoder
	instanceVariableNames: 'table delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo20-Core-Document'!

WAPharoEncoder class
	instanceVariableNames: 'table'!

WAPharoEncoder class
	instanceVariableNames: 'table'!

!WAPharoEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:50'!
delegateOn: aStream
	self subclassResponsibility! !

!WAPharoEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/14/2011 17:52'!
on: aStream
	^ self basicNew
		initializeOn: aStream
		table: table
		delegate: (self delegateOn: aStream)! !

!WAPharoEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/15/2011 08:23'!
on: aStream codec: aCodec
	self subclassResponsibility! !

!WAPharoEncoder methodsFor: 'private' stamp: 'pmm 8/14/2011 21:58'!
includesUnsafeCharacter: aString
	^ (ByteString findFirstInString: aString inSet: table startingAt: 1) ~= 0! !

!WAPharoEncoder methodsFor: 'initialization' stamp: 'pmm 8/14/2011 13:34'!
initializeOn: aStream table: anArray delegate: anEncoder
	self initializeOn: aStream.
	table := anArray.
	delegate := anEncoder.! !

!WAPharoEncoder methodsFor: 'accessing' stamp: 'pmm 8/14/2011 22:07'!
nextPut: aCharacter
	"Don't bother, directly go the the look up table"
	delegate nextPut: aCharacter! !

!WAPharoEncoder methodsFor: 'accessing' stamp: 'pmm 8/14/2011 21:59'!
nextPutAll: aString
	aString isByteString
		ifTrue: [ self nextPutAllFast: aString ]
		ifFalse: [
			"slow fall back for WideStrings"
			delegate nextPutAll: aString ]! !

!WAPharoEncoder methodsFor: 'private' stamp: 'pmm 8/14/2011 22:02'!
nextPutAllFast: aByteString
	| lastIndex nextIndex |
	lastIndex := 1.
	nextIndex := ByteString findFirstInString: aByteString inSet: table startingAt: lastIndex.
	nextIndex = 0 ifTrue: [ ^ stream nextPutAll: aByteString ].
	[	nextIndex > lastIndex ifTrue: [
			stream greaseNext: nextIndex - lastIndex putAll: aByteString startingAt: lastIndex ].
		"let the delegate do the actual encoding"
		delegate nextPut: (aByteString at: nextIndex).
		lastIndex := nextIndex + 1.
		nextIndex := ByteString findFirstInString: aByteString inSet: table startingAt: lastIndex.
		nextIndex = 0 ] whileFalse.
	stream greaseNext: aByteString size - lastIndex + 1 putAll: aByteString startingAt: lastIndex.! !

WAPharoEncoder subclass: #WAPharoUrlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo20-Core-Document'!

!WAPharoUrlEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:51'!
delegateOn: aStream
	^ WAUrlEncoder on: aStream! !

!WAPharoUrlEncoder class methodsFor: 'class initialization' stamp: 'pmm 8/14/2011 13:26'!
initialize
	self initializeUrlTable! !

!WAPharoUrlEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:49'!
initializeUrlTable
	table := ByteArray new: 256.
	1 to: 256 do: [ :index |
		('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: (Character codePoint: index - 1))
			ifTrue: [ table at: index put: 0 ]
			ifFalse: [ table at: index put: 1 ] ]! !

!WAPharoUrlEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/15/2011 08:23'!
on: aStream codec: aCodec
	^ aCodec url encoderFor: (self on: aStream)! !

WAPharoEncoder subclass: #WAPharoXmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo20-Core-Document'!

!WAPharoXmlEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:51'!
delegateOn: aStream
	^ WAXmlEncoder on: aStream! !

!WAPharoXmlEncoder class methodsFor: 'class initialization' stamp: 'pmm 8/14/2011 13:25'!
initialize
	self initializeXmlTable! !

!WAPharoXmlEncoder class methodsFor: 'class initialization' stamp: 'pmm 8/14/2011 17:50'!
initializeXmlTable
	table := ByteArray new: 256.
	1 to: 256 do: [ :index |
		('"<&>' includes: (Character codePoint: index - 1))
			ifTrue: [ table at: index put: 1 ]
			ifFalse: [ table at: index put: 0 ] ]! !

!WAPharoXmlEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/15/2011 08:23'!
on: aStream codec: aCodec
	^ self on: aStream! !
WAPharoXmlEncoder initialize!
WAPharoUrlEncoder initialize!
